n, m, k = map(int, input().split())
graph = [[] for _ in range(n + 1)]

for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)


guarded = set()


for _ in range(k):
    p, h = map(int, input().split())


    queue = [(p, 0)]
    visited = [False] * (n + 1)
    visited[p] = True

    while queue:
        current, distance = queue.pop(0)

        guarded.add(current)


        if distance < h:
            for neighbor in graph[current]:
                if not visited[neighbor]:
                    visited[neighbor] = True
                    queue.append((neighbor, distance + 1))


guarded_warehouses = sorted(guarded)


print(' '.join(map(str, guarded_warehouses)))





















#5 5 2
#1 2
#2 3
#2 4
#3 5
#1 5
#1 2
#5 1




