def lunar_add(a, b):

    max_len = max(len(a), len(b))
    a = a.zfill(max_len)
    b = b.zfill(max_len)
    return "".join(str(max(int(x), int(y))) for x, y in zip(a, b))


def lunar_multiply(a, b):

    if not a or not b:
        return "0"

    rows = []
    for digit_b in b:
        row = "".join(str(min(int(digit_a), int(digit_b))) for digit_a in a)
        rows.append(row)

    max_len = max(map(len, rows))
    result = ""
    for i in range(max_len):
        col_max = 0
        for row in rows:
            digit = int(row[len(row) - 1 - i]) if i < len(row) else 0
            col_max = max(col_max, digit)
        result = str(col_max) + result
    return result.lstrip("0") or "0"


a = input()
b = input()
print(lunar_add(a, b), lunar_multiply(a, b))



